/*

Politecnico di Torino - Fondamenti di Informatica (06AZN)

una possibile soluzione del tema d'esame del 9/2/2012

*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define MAXLUOGO 64
#define MAXDATA 10
#define MAXBC 127 

#define BOOLEAN int
#define FALSE 0
#define TRUE (!FALSE)

struct _rilevamento {
  char data[MAXDATA+1];
  char luogo[MAXLUOGO+1];
  float tmin;
  float tmax;
};

typedef struct _rilevamento rilevamento;
  
int main (int argc, char *argv[])
{
  rilevamento misura, min_misura;
  int numero_misure = 0;
  float totale, media;
  
  BOOLEAN calcolo_globale = TRUE;
  FILE *afh;
  char buf[MAXBC+1];

  if (argc != 2 && argc != 3) {
    fprintf (stderr, "errore - inserire il nome del file dei rilevamenti (e opzionalmente la citta')\n");
    exit (1);
  }

  if ((afh=fopen(argv[1],"r")) == NULL) {
    fprintf (stderr, "errore - impossibile aprire il file %s in lettura\n", argv[1]);
    exit (1);
  }

  if (argc == 3) 
    calcolo_globale = FALSE;

  while (fgets(buf,MAXBC,afh) != NULL)
  {
    if ((sscanf (buf, "%s %s %f %f\n",
      misura.data, misura.luogo, &misura.tmin, &misura.tmax) != 4))
    {
      /* riga ignorata (contiene numero di dati errato) */
      fprintf (stderr, "errore - riga sbagliata:\n%s\n", buf);
      continue;
    }

    if (!calcolo_globale)
    {
      if (strcmp (misura.luogo, argv[2]) != 0)
      {
	/* riga ignorata (non contiene dati relativi alla citta') */
        continue;
      }
    }

    if (numero_misure == 0) /* prima misura: inizializzo il minimo */
    {
      strcpy (min_misura.data, misura.data);
      strcpy (min_misura.luogo, misura.luogo);
      min_misura.tmin = misura.tmin;
    }
    else /* misure successive: aggiorno il minimo */
    {
      if (misura.tmin < min_misura.tmin)
      {
        strcpy (min_misura.data, misura.data);
        strcpy (min_misura.luogo, misura.luogo);
        min_misura.tmin = misura.tmin;
      }
    }
    numero_misure ++;
    totale += misura.tmin;
  }

  if (numero_misure == 0) 
  {
    if (calcolo_globale)
      fprintf (stderr, "avviso - archivio %s vuoto, nessuna rilevazione\n", argv[1]);
    else
      fprintf (stderr, "avviso - archivio %s non contiene rilevazioni per la citta' %s\n", argv[1], argv[2]);
    exit (1);
  }

  media = totale / (float) numero_misure;
  
  if (calcolo_globale)
  {
    printf ("temperatura minima rilevata: %.1f il %s a %s\n",
      min_misura.tmin, min_misura.data, min_misura.luogo);
    printf ("temperatura minima prevista: %.1f\n", media);
  }
  else
  {
    printf ("temperatura minima rilevata a %s: %.1f il %s\n",
      min_misura.luogo, min_misura.tmin, min_misura.data);
    printf ("temperatura minima prevista a %s: %.1f\n", 
       min_misura.luogo, media);
  }

  if (fclose(afh))
    fprintf (stderr, "avviso - fallita chiusura del file %s\n", argv[1]);

  return 0;
}
